



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>luogu3953 [NOIp2017]逛公园 (tarjan+dijkstra+记忆化搜索)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">luogu3953 [NOIp2017]逛公园 (tarjan+dijkstra+记忆化搜索)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 22:59:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>先跑一边dijkstra算出从1到i的最短距离dis[i]</p>
<p>然后建反向边 从n开始记忆化搜索，(p,k)表示1到p的距离=dis[p]+k的方案数</p>
<p>答案就是$\sum\limits_{i=0}^{k}{(n,i)}$</p>
<p>考虑0环，如果我记搜的时候搜到了0环，那答案就是-1，可以先用tarjan处理一下0边 看看有哪些点在零环上</p>
<p>（其实也可以开个栈 做到(p,k)的时候看(p,k)是不是已经在栈中了 如果是那就是-1）</p>
<div>
<pre class="prettyprint linenums"> #include&lt;bits/stdc++.h&gt;<br />
 #define CLR(a,x) memset(a,x,sizeof(a))<br />
 using namespace std;<br />
 typedef long long ll;<br />
 typedef pair&lt;int,int&gt; pa;<br />
 const int maxn=1e5+,maxm=2e5+,maxk=;

 inline ll rd(){<br />
     ll x=;char c=getchar();int neg=;<br />
     while(c&lt;''||c&gt;''){if(c=='-') neg=-;c=getchar();}<br />
     while(c&gt;=''&amp;&amp;c&lt;='') x=x*+c-'',c=getchar();<br />
     return x*neg;<br />
 }

 struct Edge{<br />
     int b,l,ne;<br />
 }eg[maxm],neg[maxm];<br />
 struct Node{<br />
     int p,k,n;<br />
     Node(int a=,int b=,int c=){p=a,k=b,n=c;}<br />
 };<br />
 int egh[maxn],negh[maxn],ect,nect;<br />
 int dis[maxn],f[maxn][maxk];<br />
 int dfn[maxn],tot,low[maxn],stk[maxn],sh;<br />
 int N,M,K,P;<br />
 bool in0[maxn],instk[maxn],flag[maxn];

 inline void adeg(int a,int b,int c){<br />
     eg[++ect].b=b,eg[ect].l=c,eg[ect].ne=egh[a],egh[a]=ect;<br />
     neg[++nect].b=a,neg[nect].l=c,neg[nect].ne=negh[b],negh[b]=nect;<br />
 }

 void tarjan(int x){<br />
     dfn[x]=low[x]=++tot,instk[x]=,stk[++sh]=x;<br />
     for(int i=egh[x];i;i=eg[i].ne){<br />
         if(eg[i].l) continue;<br />
         int b=eg[i].b;<br />
         if(!dfn[b]) tarjan(b),low[x]=min(low[x],low[b]);<br />
         else if(instk[b]) low[x]=min(low[x],dfn[b]);<br />
     }<br />
     if(dfn[x]==low[x]){<br />
         int n=;<br />
         for(int i=sh;stk[i]!=x;i--) n++;<br />
         while(){<br />
             instk[stk[sh]]=;<br />
             in0[stk[sh]]=n&gt;;<br />
             if(stk[sh--]==x) break;<br />
         }<br />
     }<br />
 }

 priority_queue&lt;pa,vector&lt;pa&gt;,greater&lt;pa&gt; &gt; q;<br />
 inline void dijkstra(){<br />
     while(!q.empty()) q.pop();<br />
     CLR(flag,);CLR(dis,);dis[]=;<br />
     q.push(make_pair(,));<br />
     while(!q.empty()){<br />
         int p=q.top().second;q.pop();<br />
         if(flag[p]) continue;<br />
         flag[p]=;<br />
         for(int i=egh[p];i;i=eg[i].ne){<br />
             int b=eg[i].b;<br />
             if(dis[b]&gt;dis[p]+eg[i].l){<br />
                 dis[b]=dis[p]+eg[i].l;<br />
                 q.push(make_pair(dis[b],b));<br />
             }<br />
         }<br />
     }<br />
 }

 inline int solve(int x,int y){<br />
     // if(f[x][y]&gt;=0) printf("get%d %d %d\n",x,y,f[x][y]);<br />
     if(y&lt;||y&gt;K) return ;<br />
     if(in0[x]) return -;<br />
     if(f[x][y]&gt;=) return f[x][y];<br />
     f[x][y]=;<br />
     for(int i=negh[x];i;i=neg[i].ne){<br />
         int b=neg[i].b;<br />
         int re=solve(b,dis[x]-dis[b]+y-neg[i].l);<br />
         if(re==-) return -;<br />
         f[x][y]+=re,f[x][y]%=P;<br />
     }<br />
     return f[x][y];<br />
 }

 int main(){<br />
     int i,j,k;<br />
     for(int T=rd();T;T--){<br />
         N=rd(),M=rd(),K=rd(),P=rd();<br />
         CLR(egh,);ect=;<br />
         CLR(negh,);nect=;<br />
         for(i=;i&lt;=M;i++){<br />
             int a=rd(),b=rd(),c=rd();<br />
             adeg(a,b,c);<br />
         }<br />
         CLR(dfn,);CLR(instk,);tot=;CLR(in0,);<br />
         for(i=;i&lt;=N;i++)<br />
             if(!dfn[i]) tarjan(i);<br />
         dijkstra();<br />
         CLR(f,-);<br />
         f[][]=;int ans=;<br />
         for(i=;i&lt;=K;i++)<br />
             ans+=solve(N,i),ans%=P;<br />
         printf("%d\n",ans&lt;?-:ans);<br />
     }

     return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zrovqy.html">JavaScript中String对象的方法介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kk5vr8.html">【动态规划】bzoj1663 &lbrack;Usaco2006 Open&rsqb;赶集</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxrl7vq.html">BSA基础数据维护</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyn2ex9.html">log4net的配置与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zd7kn9.html">关于obj和基本类通过函数参数传进去执行是否改变原来的值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k11yz79.html">eclipse隐藏菜单栏实现全部酷黑主题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1jy69.html">LoadRunner用户行为模拟器 《第三篇》</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn6yev8.html">mysql定时脚本（event），类似oracle的job</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm7yvl9.html">Eclipse下Maven插件配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp1dm79.html">python 内存泄露的诊断 - 独立思考 - ITeye技术网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv13m71q.html">python学习总结笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1oy1xq.html">&lbrack;Luogu3676&rsqb;小清新数据结构题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k1mr29.html">一、下载安装superset</a>
		</li>
						<li><a href="https://www.batexi.com/a/960pykv9.html">C&num; 异步机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv41v28.html">Oracle表中的主键被当成哪些表的外键</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kop2ljq.html">冰血暴第一季&sol;全集Fargo迅雷下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql10v119.html">&lpar;16&rpar;Cocos2d-x 多分辨率适配完全解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1veo12q.html">Linux网络编程之聊天程序&lpar;TCP协议之select&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwod0wk9.html">erl&lowbar;0021 erlang和java的内存模型比较（引用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwoodkk9.html">&lbrack;C&plus;&plus;&rsqb; OOP - Virtual Functions and Abstract Base Classes</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gj33349.html">&num; 【Python3练习题 007】 有一对兔子，从出生后第3个月起每个月都生一对兔子， &num; 小兔子长到第三个月后每个月又生一对兔子， &num; 假如兔子都不死，问每个月的兔子总数为多少？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r5pj68.html">&lbrack;转帖&rsqb; bat方式遍历目录内的文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllo5g0q.html">javascript深入浅出&mdash;&mdash;学习笔记&lpar;六种数据类型和隐式转换&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r541xdq.html">php-memcached详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1d3llq.html">jdbc一点小笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllowx1q.html">docker 列出每个容器的IP</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e40ree9.html">java 中的Collection</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjmdyr9.html">Reading Text from Images Using C&num;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdlxnd9.html">Web API 2 使用SSL</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy2xngq.html">&lbrack;SimplePlayer&rsqb; 实现一个简单的播放器</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
